HOME_FULL= /home/james
DEV_TOOLS= $(HOME_FULL)/DevTools
TOOLCHAIN= $(DEV_TOOLS)/custom-toolchain
NDK_FULL = $(DEV_TOOLS)/android-ndk-r8d
INCLUDE  = -I.. -I$(TOOLCHAIN) -I$(DEV_TOOLS)/bullet-2.81-rev2613/src 
CXXFLAGS = -DANDROID_NDK $(INCLUDE) -O2 --std=c++0x

CXX      = $(TOOLCHAIN)/bin/arm-linux-androideabi-gcc-4.8 
AR		 = $(TOOLCHAIN)/bin/arm-linux-androideabi-ar

SOURCES  = \
	PanelManager.cpp \
	PositionHandler.cpp \
	VisibilityHandler.cpp \
	Panel.cpp \
	Font.cpp \

OBJS = $(SOURCES:%.cpp=obj/%.obj)

obj/%.obj: %.cpp
	$(CXX) $(CXXFLAGS) -o $@ -c $< 

all: $(OBJS)
	$(AR) rc ../lib/Panels.a $^

clean: 
	rm -rf obj/*.obj *~


