#include "Panel.h"

#include <Utility/Log.h>

#include <algorithm>

//////////////////////////////////////////////////////////////
namespace Dubious {
namespace Panels {

//////////////////////////////////////////////////////////////
Panel::Panel()
{
}

//////////////////////////////////////////////////////////////
Panel::Panel( PanelPtr pParent )
	: PositionHandler( pParent )
{
}

//////////////////////////////////////////////////////////////
Panel::~Panel()
{
}

//////////////////////////////////////////////////////////////
PanelPtr Panel::Create()
{
	return PanelPtr( new Panel() );
}

//////////////////////////////////////////////////////////////
PanelPtr Panel::Create( PanelPtr pParent )
{
	PanelPtr pThis( new Panel( pParent ) );
	pParent->Children().push_back( pThis );
	return pThis;
}

//////////////////////////////////////////////////////////////
void Panel::Draw()
{
	if (m_OnDraw) {
		m_OnDraw();
	}
	std::for_each( m_Children.begin(), m_Children.end(), []( PanelPtr pChild ){
		pChild->Draw();
	});
}

//////////////////////////////////////////////////////////////
bool Panel::Contains( const Math::Point& P ) const
{
	Math::Point ScreenPos = GetPosition();
	if (P.X() < ScreenPos.X() || P.Y() < ScreenPos.Y()) {
		return false;
	}
	Math::Point SecondPos = ScreenPos + Math::Point( Size().X(), Size().Y() );
	return P.X() < SecondPos.X() && P.Y() < SecondPos.Y();
}

}
}
