HOME_FULL= C:/Users/James
DEV_TOOLS= $(HOME_FULL)/DevTools/Android
TOOLCHAIN= $(DEV_TOOLS)/ndk-toolchain
INCLUDE  = -I.. -I$(TOOLCHAIN) -I$(DEV_TOOLS)/bullet-2.81-rev2613/src \
	-I$(DEV_TOOLS)/libpng-1.5.13$ 
CXXFLAGS = -DANDROID_NDK $(INCLUDE) -O2 --std=c++0x

CXX      = $(TOOLCHAIN)/bin/arm-linux-androideabi-gcc-4.8 
AR		 = $(TOOLCHAIN)/bin/arm-linux-androideabi-ar

SOURCES  = \
	glu.cpp \
	Camera.cpp \
	Color.cpp \
	Model.cpp \
	OpenGLMatrix.cpp \
	OpenGLUtils.cpp \
	Scene.cpp \
	ShadowRenderer.cpp \
	ObjectRenderer.cpp \
	SimpleObjectRenderer.cpp \
	OutlinedObjectRenderer.cpp \
	VisibleObject.cpp \
	PngImage.cpp \
	Billboard.cpp \
	BillboardRenderer.cpp \

OBJS = $(SOURCES:%.cpp=obj/%.obj)

obj/%.obj: %.cpp
	$(CXX) $(CXXFLAGS) -o $@ -c $< 

all: $(OBJS)
	$(AR) rc ../lib/Renderer.a $^

clean: 
	rm -rf obj/*.obj *~


