#include "Timer.h"

//////////////////////////////////////////////////////////////
namespace Dubious
{
namespace Utility
{

////////////////////////////////////////////////////////////////////////////////////
Timer::Timer()
{
	Start();
}

////////////////////////////////////////////////////////////////////////////////////
Timer::~Timer()
{
}

////////////////////////////////////////////////////////////////////////////////////
void Timer::Start()
{
	clock_gettime( CLOCK_MONOTONIC, &m_TimeSpec );
}

////////////////////////////////////////////////////////////////////////////////////
unsigned long Timer::Restart()
{
	struct timespec Current;
	clock_gettime( CLOCK_MONOTONIC, &Current );

	unsigned long RetVal = (Current.tv_sec * 1000 + static_cast<float>(Current.tv_nsec)/1000000.0) -
						   (m_TimeSpec.tv_sec * 1000 + static_cast<float>(m_TimeSpec.tv_nsec)/1000000.0);

	m_TimeSpec = Current;

	return RetVal;
}

////////////////////////////////////////////////////////////////////////////////////
unsigned long Timer::Elapsed() const
{
	struct timespec Current;
	clock_gettime( CLOCK_MONOTONIC, &Current );

	return (Current.tv_sec * 1000 + static_cast<float>(Current.tv_nsec)/1000000.0) -
		   (m_TimeSpec.tv_sec * 1000 + static_cast<float>(m_TimeSpec.tv_nsec)/1000000.0);
}

}
}
