LOCAL_PATH := $(call my-dir)
DEV_TOOLS := C:/Users/james/DevTools/Android
PROJECTS := C:/Users/james/Projects/Android

include $(CLEAR_VARS)
LOCAL_MODULE := DubiousUtility
LOCAL_SRC_FILES := $(PROJECTS)/DubiousEngine/lib/Utility.a
include $(PREBUILT_STATIC_LIBRARY)
   
include $(CLEAR_VARS)
LOCAL_MODULE := DubiousMath
LOCAL_SRC_FILES := $(PROJECTS)/DubiousEngine/lib/Math.a
include $(PREBUILT_STATIC_LIBRARY)
   
include $(CLEAR_VARS)
LOCAL_MODULE := DubiousRenderer
LOCAL_SRC_FILES := $(PROJECTS)/DubiousEngine/lib/Renderer.a
include $(PREBUILT_STATIC_LIBRARY)
   
include $(CLEAR_VARS)
LOCAL_MODULE := DubiousPhysics
LOCAL_SRC_FILES := $(PROJECTS)/DubiousEngine/lib/Physics.a
include $(PREBUILT_STATIC_LIBRARY)
   
include $(CLEAR_VARS)
LOCAL_MODULE := LinearMath
LOCAL_SRC_FILES := $(DEV_TOOLS)/bullet-2.81-rev2613/lib/LinearMath.a
include $(PREBUILT_STATIC_LIBRARY)
   
include $(CLEAR_VARS)
LOCAL_MODULE := BulletDynamics
LOCAL_SRC_FILES := $(DEV_TOOLS)/bullet-2.81-rev2613/lib/BulletDynamics.a
include $(PREBUILT_STATIC_LIBRARY)
   
include $(CLEAR_VARS)
LOCAL_MODULE := BulletCollision
LOCAL_SRC_FILES := $(DEV_TOOLS)/bullet-2.81-rev2613/lib/BulletCollision.a
include $(PREBUILT_STATIC_LIBRARY)
   
include $(CLEAR_VARS)
LOCAL_MODULE := xsde
LOCAL_SRC_FILES := $(DEV_TOOLS)/xsde-3.2.0-i686-windows/lib/libxsde.a
include $(PREBUILT_STATIC_LIBRARY)
   
include $(CLEAR_VARS)
LOCAL_MODULE := png
LOCAL_SRC_FILES := $(DEV_TOOLS)/libpng-1.5.13/lib/libpng.a
include $(PREBUILT_STATIC_LIBRARY)
   
include $(CLEAR_VARS)

LOCAL_MODULE    := NativeSakana
LOCAL_SRC_FILES := \
	SceneDescription/SceneDescription.cpp \
	SceneDescription/SceneDescription-pimpl.cpp \
	SceneDescription/SceneDescription-pskel.cpp \
	WeaponDescription/WeaponDescription.cpp \
	WeaponDescription/WeaponDescription-pimpl.cpp \
	WeaponDescription/WeaponDescription-pskel.cpp \
	NativeSakana.cpp \
	GameScreen.cpp \
	Object.cpp \
	SceneReader.cpp \
	Weapon.cpp \
	ModelStore.cpp \
	Explosion.cpp 

LOCAL_C_INCLUDES := \
	$(PROJECTS)/DubiousEngine \
	$(DEV_TOOLS)/bullet-2.81-rev2613/src \
	$(DEV_TOOLS)/xsde-3.2.0-i686-windows/libxsde \

LOCAL_CFLAGS    := \
	--std=c++0x \
	-O2 \
	-DANDROID_NDK \

LOCAL_CPP_FEATURES += exceptions			
LOCAL_LDLIBS    := \
	-llog -landroid -lEGL -lGLESv1_CM -lz
	
LOCAL_STATIC_LIBRARIES := \
	DubiousPhysics DubiousUtility DubiousRenderer DubiousMath \
	BulletDynamics BulletCollision LinearMath \
	xsde png \
	android_native_app_glue

include $(BUILD_SHARED_LIBRARY)

$(call import-module,android/native_app_glue)
